#ifndef CLOGIC_ONCE
#define CLOGIC_ONCE
#include "CTimeTag.h"


namespace TimeTag
{
    class CLogic
    {
        int* logic;
		bool ecSet;
		bool owSet;
        CHelper *helper;
		CUsb *usb;
        CTimeTag *ttInterface;
		static const int maxDelay = (1 << 24) - 1;
		static const int inputs = 16;
        static const int lSize = 1 << 16;



	private:
		int bitCount(int p);
        void InitOutputs();
		

	public:
		 CLogic(CTimeTag *tti);


        void SwitchLogicMode();
        
        void SetWindowWidth(int window);
		void SetWindowWidthEx(int index, int window);
        void SetDelay(int input, int delay);
        void ReadLogic();
        int CalcCountPos(int pattern);

        int CalcCount(int pos, int neg);
        int GetTimeCounter();
		double GetTime();

        void SetOutputWidth(int width);

        void SetOutputPattern(int output, int pos, int neg);
        void SetOutputEventCount(int events);
		void DefinePattern(int number, unsigned long long regard);
		void DefinePatternNeg(int number, unsigned long long pos, unsigned long long neg);

		
		int GetSingleCount(int i);
		int GetPatternCount(int i);
		void SetCompactorBit (int group, int index, bool value);
		void SetCompactorCount (int group, int bitCount);

		void DoLogicReset (int mask); //Temp




    };
}
#endif